leetcode每日一题34

89.格雷编码

观察一下n不同时的格雷编码有什么特点

n=1 0,1

n=2 0,1,3,2

n=3 0,1,3,2,6,7,5,4

......

可以看到n=k时,编码数量是n=k-1的数量的一倍

同时n=k编码的前半部分和n=k-1一模一样

n=k编码的最后一位是2k-1

后半部分的编码是其对应的前半部分的对称的位置的数字+2k-1
如图可以看出原理,为了增加长度后,使得隔着中轴线相邻的第2k-1位和第2k-1+1位差一位,那么就要在新增加的位上由0变1(因为前半部分出现过在原有的位上是1的编码了)

也就是数字上增加了2k-1

至于其他的位,因为按照前面的编码放置1的顺序是唯一的,所以只要在最高位都填1,然后对称着顺序来就好了

因此代码为

cpp 复制代码
class Solution {
public:
    vector<int> grayCode(int n) {
        vector<int> gray;
        gray.push_back(0);
        gray.push_back(1);
        if(n==1)
            return gray;
        for(int i=2;i<=n;i++)
        {
            for(int j=pow(2,i-1)-1;j>=0;j--)
            {
                gray.push_back(gray[j]+pow(2,i-1));
            }
        }
        return gray;
    }
};

格雷编码有相当多的生成方法

还有一种,比如说G(i)=(i ^ (i >> 1))也就是G(i)=i^(i/2)
从这个图可以看出,如果二进制码字的第 i 位和 i+1 位(从右边开始数)相同,则对应的格雷码的第i位为0,否则为1(当i+1=n时,二进制码字的第n位被认为是0,即第n-1位不变)

cpp 复制代码
class Solution {
public:
    vector<int> grayCode(int n) {
        vector<int> gray;
        for(int i=0;i<pow(2,n);i++)
            gray.push_back(i^i>>1);
        return gray;
    }
};
相关推荐
一去不复返的通信er1 小时前
力扣-图论-岛屿数量
算法·leetcode·图论
考研保研资料分享3 小时前
985工科跨保上财应用统计:数学笔试、匿名面试与机试复盘
面试·职场和发展
程序 代码狂人4 小时前
切片表与分区表的区别(数据开发面试版)
java·大数据·开发语言·数据仓库·算法
HDU-Dade5 小时前
【校招笔试真题】简要介绍 Self-Attention 的前沿算法
人工智能·算法
Xin7706 小时前
LeetCode 79. 单词搜索(DFS 回溯法)
leetcode
小郎君6587 小时前
Vue keep-alive 切标签后滚动位置回顶?因为 onDeactivated 里读到的 scrollTop 是 0
算法
邵奈一7 小时前
GPT-6.1 Terra速度是Sol的3倍,价格减半
算法
RaaS1007 小时前
Node.js Brotli RCE 漏洞自查指南:fetch、undici、axios 都在影响面,三分钟确认你的版本
人工智能·深度学习·算法
shehuiyuelaiyuehao8 小时前
算法56,重排链表
数据结构·算法·链表